<template>
  <section v-if="task">
    <md-toolbar>
      <h1 class="md-title" style="flex: 1; text-align: left">{{ task.title }}</h1>
      <i :class="`task__text--${task.className}`">{{ task.status.title }}</i>
      <md-button class="task__btn" @click="showEditModal">Редактировать</md-button>
    </md-toolbar>
    <md-content class="container task__container">
      <strong>{{ task.message }}</strong>
    </md-content>
    <md-dialog :md-active.sync="isEditModalShow">
      <md-card class="card">
        <md-card-content>
          <md-field>
            <label>Заголовок *</label>
            <md-input v-model="localTask.title"></md-input>
          </md-field>
          <md-field>
            <label>Описание *</label>
            <md-input v-model="localTask.message"></md-input>
          </md-field>
        </md-card-content>

        <md-card-actions>
          <md-button @click="isEditModalShow = false">Отменить</md-button>
          <md-button @click="saveTask">Сохранить</md-button>
        </md-card-actions>
      </md-card>
    </md-dialog>
  </section>
  <section v-else>
    <md-progress-spinner md-mode="indeterminate" class="spinner"></md-progress-spinner>
  </section>
</template>

<script>
export default {
  name: 'Task',
  props: {
    id: [String, Number],
  },
  data() {
    return {
      status: {
        done: 'Выполнено',
        active: 'В работе',
        overdue: 'Просрочено',
      },
      task: null,
      localTask: {},
      isEditModalShow: false,
    };
  },
  async mounted() {
    try {
      const { data } = await this.$api.post(`request/show/${this.id}`);
      if (data.error) {
        this.$router.push({ name: 'TaskList' });
      } else {
        this.task = data.data;
      }
    } catch (error) {
      console.error(error);
    }
  },
  methods: {
    showEditModal() {
      this.isEditModalShow = true;
      this.localTask = { ...this.task };
    },
    async saveTask() {
      const backup = { ...this.task };
      this.isEditModalShow = false;
      this.task = { ...this.localTask };
      const params = {
        title: this.localTask.title,
        message: this.localTask.message,
      };

      try {
        const { data } = await this.$api.post(`request/edit/${this.id}`, params);
        if (data.error) {
          this.task = backup;
        }
      } catch (error) {
        this.task = backup;
      }
    },
  },
};
</script>
<style lang="scss" scoped>
.task {
  &__container {
    padding-top: 16px;
    text-align: left;
    background: none !important;
  }

  &__btn {
    background-color: #37ce7e;
    border-radius: 4px;

    &::v-deep .md-button-content {
      font-size: 16px;
      font-weight: bold;
      color: #fff;
      text-transform: none;
    }
  }

  &__text {
    &--done {
      color: #37ce7e;
    }

    &--active {
      color: #4c7397;
    }

    &--overdue {
      color: #db545a;
    }
  }
}
.spinner {
  margin: 200px auto 0;
}
</style>
